//
//  EMTI_ID3Classifier.hpp
//  EMTI
//
//  Created by Anders Nikolai Fuglseth on 07.11.2015.

#ifndef EMTI_ID3Classifier_hpp
#define EMTI_ID3Classifier_hpp

#include <stdio.h>
#include <math.h>
#include <vector>
#include <set>

#include "EMTI_DecisionTree.hpp"

class EMTI_ID3Classifier {
public:
    
    EMTI_ID3Classifier (vector<vector<unsigned>>* trainingSet, vector<int>* fullAttributeScope);
    
    ~EMTI_ID3Classifier ();
    
    void makeTree();
    
    EMTI_TreeNode* ID3Algorithm (set<int> remainingAttributes, vector<vector<unsigned>>* subSet, EMTI_TreeNode* parent = NULL);
    
    int classify(vector<unsigned> entry);
    
    double gain (int attribute, vector<vector<unsigned>>* subSet);
    
    double entropy (int categoryScope, vector<vector<unsigned>>* subSet);
    
    bool isPure (vector<vector<unsigned>>* set);
    
    vector<vector<unsigned>>* newSubset (vector<vector<unsigned>>* set, int attribute, int attributeValue);
    
    
    
    EMTI_DecisionTree* tree;
    
    vector<vector<unsigned>>* trainingSet;
    vector<int>* fullAttributeScope;
    
    int categoryScope;
};

#endif /* EMTI_ID3Classifier_hpp */
