//
//  Flatland.cpp
//  ANN_Flatland
//
//  Created by aviVidi on 16.04.15.
//  Copyright (c) 2015 Anders Fuglseth. All rights reserved.
//

#include "Flatland.h"

Flatland::Flatland (int dimensions, double foodDist, double poisDist) {
    
    agent = new Agent (6, 3);
    
    /* initialize random seed based on current time*/
    srand ((int)time(NULL));
    
    board = new GameBoard(dimensions, foodDist, poisDist, -6, 2);
    
    board->setFoodAndPoisonDist(foodDist, poisDist);
    
    //makeRandomBoard(dimensions, foodDist, poisDist);
    setScenario(2);
    
    //std::cout << board->toString();
    
    //agent = new Agent (6, 3, getAgentInput(agentDirection));
    
    
}

int Flatland::randomNumber(int start, int end) {
    int range = end - start + 1;
    int number;
    
    if (end>start) {
        number = rand() % range + start;
    }
    else {
        number = start;
    }
    
    return number;
}


void Flatland::makeRandomBoard (int dimensions, double foodDist, double poisDist) {
    
    agent->currentScore = 1000; //#### OBS ####
    
    board->nullify();
    
    agent->agentPosition = {randomNumber(0, dimensions-1), randomNumber(0, dimensions-1)};
    
    board->agentPosition = agent->agentPosition;
    
    board->setPositionValue(agent->agentPosition.first, agent->agentPosition.second, 1);
    
    agent->agentDirection = randomNumber(0, 3);
    
    board->setFoodAndPoisonDist(foodDist, poisDist);
    
    board->fillRandom();
}

void Flatland::setScenario(int scenario) {
    switch (scenario) {
        case 1:
            agent->agentPosition = {6, 1};
            board->agentPosition = agent->agentPosition;
            board->setPositionValue(agent->agentPosition.first, agent->agentPosition.second, 1);
            agent->agentDirection = 2;
            board->setStaticScenario(1);
            break;
        case 2:
            agent->agentPosition = {3, 4};
            board->agentPosition = agent->agentPosition;
            board->setPositionValue(agent->agentPosition.first, agent->agentPosition.second, 1);
            agent->agentDirection = 3;
            board->setStaticScenario(2);
        default:
            break;
    }
}











