//
//  Agent.h
//  EMTI_Flatland
//
//  Created by aviVidi on 21.04.16.
//  Copyright (c) 2016 Anders Fuglseth. All rights reserved.
//

#ifndef __EMTI_Flatland__Agent__
#define __EMTI_Flatland__Agent__

#include <stdio.h>
#include <vector>
#include <iostream>

#include "EMTI_population.hpp"

#include "EMTI_DotTreeWrapper.hpp"

#include "GameBoard.h"

class Agent {
public:
    
    //TODO collect parameters here
    
    Agent(int numInputs, int numOutputs);
    
    EMTI_Population* p;
    
    int numInputs;
    
    int numOutputs;
    
    int testScenarioCount = 50;
    
    int evaluationRunMoveCount = 50;
    
    int act (std::vector<bool>* input);
    
    void buildAI (GameBoard* board, bool dynamic);
    
    int evaluationRun(GameBoard* testBoard, int steps);
    
    int agentDirection = 0;
    /* 0 = North
     1 = East
     2 = South
     3 = West
     */
    std::pair<int, int> agentPosition = {0,0};
    
    int currentScore = 1000;
    
private:
    
    EMTI_DecisionTree* decisionTree;
    
    int currentAction = 0;
    /* 0 = nothing
       1 = front
       2 = right
       3 = left */
    
    
    int randomNumber(int start, int end);
};


#endif /* defined(__EMTI_Flatland__Agent__) */
