//
//  EMTI_AdultSelection.hpp
//  EMTI0.2_OSX
//
//  Created by aviVidi on 04.02.2016.
//  Copyright © 2016 Anders Nikolai Fuglseth. All rights reserved.
//

#ifndef EMTI_AdultSelection_hpp
#define EMTI_AdultSelection_hpp

#include <vector>

#include "EMTI_TreeCreature.hpp"

using namespace std;


class EMTI_AdultSelection {
public:
    
    enum type
    {
        full_generational_replacement_selection,
        overproduction_selection,
        generational_mixing_selection,
        generational_mixing_add_spice_selection
    };
    
    static vector<EMTI_TreeCreature*>* full_generational_replacement (vector<EMTI_TreeCreature*>* children, vector<EMTI_TreeCreature*>* adults);
    
    static vector<EMTI_TreeCreature*>* overproduction (vector<EMTI_TreeCreature*>* children, vector<EMTI_TreeCreature*>* adults, int populationSize);
    
    static vector<EMTI_TreeCreature*>* generational_mixing (vector<EMTI_TreeCreature*>* children, vector<EMTI_TreeCreature*>* adults);
    
    static vector<EMTI_TreeCreature*>* generational_mixing_add_spice (vector<EMTI_TreeCreature*>* children, vector<EMTI_TreeCreature*>* adults, float spiceRatio, vector<int>* fullAttributeScope, vector<vector<unsigned>>* trainingSet, int sizeWeight);
    
private:
    
    static bool compareFitness (EMTI_TreeCreature* a, EMTI_TreeCreature* b);
};

#endif /* EMTI_AdultSelection_hpp */