//
//  EMTI_ParentSelection.hpp
//  EMTI0.2_OSX
//
//  Created by aviVidi on 04.02.2016.
//  Copyright © 2016 Anders Nikolai Fuglseth. All rights reserved.
//

#ifndef EMTI_ParentSelection_hpp
#define EMTI_ParentSelection_hpp

#include <utility>
#include <set>

#include "EMTI_TreeCreature.hpp"

using namespace std;

class EMTI_ParentSelection {
public:
    
    enum type
    {
        fitness_proportionate_selection,
        tournament_selection,
        sigma_scaling_selection
    };
    
    static pair<EMTI_TreeCreature*, EMTI_TreeCreature*> fitness_proportionate (vector<EMTI_TreeCreature*>* adults);
    
    static pair<EMTI_TreeCreature*, EMTI_TreeCreature*> tournament (vector<EMTI_TreeCreature*>* adults, int size, double e);
    
    static pair<EMTI_TreeCreature*, EMTI_TreeCreature*> sigma_scaling (vector<EMTI_TreeCreature*>* adults, float averageFitness, float sdFitness);
    
private:
    
    static EMTI_TreeCreature* single_tournament (vector<EMTI_TreeCreature*>* adults, int size, double e);
    
    static int random_number(int start, int end);
    
    static double random_double(double start, double end);
    
    static bool choice_is_random(double e);
    
};

#endif /* EMTI_ParentSelection_hpp */
