//
//  BoidControl.m
//  Boids
//
//  Created by aviVidi on 10.02.15.
//  Copyright (c) 2015 Anders Fuglseth. All rights reserved.
//

#import "FlatControl.h"



@implementation FlatControl {
    @private
    
    Flatland* flatland;
    
    int poisonEaten;
    
    int foodEaten;
}
//{
//    NSTimer *t;
//}




- (void)drawRect:(NSRect)dirtyRect {
    [super drawRect:dirtyRect];
    
}

- (id)init {
    
    flatland = new Flatland (10,0.33,0.33);
    
    _dimension = 10;
    
    _dynamic = true;
    
    foodEaten = 0;
    poisonEaten = 0;
    
    [_fview initWithDimension:_dimension];
    
    [_fview drawBoard:flatland];

    return self;
}

-(IBAction)moveFront:(id)sender {
    

    
    [self move:1];
}

-(IBAction)moveRight:(id)sender {
    
    [self move:2];
}

-(IBAction)moveLeft:(id)sender {
    
    [self move:3];
    
    }

-(IBAction)newScenario:(id)sender {
    
    foodEaten = 0;
    poisonEaten = 0;
    
    flatland->makeRandomBoard(_dimension, [_foodDistText floatValue], [_poisDistText floatValue]);
    [_fview drawBoard:flatland];
    [_scoreText setStringValue:[NSString stringWithFormat:@"%d",flatland->agent->currentScore]];
}

- (BOOL)acceptsFirstResponder {
    return YES;
}


-(IBAction)aiMove:(id)sender {
    int action = flatland->agent->act(flatland->board->getAgentInput(flatland->agent->agentDirection));
    if (action > 0) {
    [self move:action];
    }
    
}

-(IBAction)moveUp:(id)sender
{
    int action = flatland->agent->act(flatland->board->getAgentInput(flatland->agent->agentDirection));
    if (action > 0) {
        [self move:action];
    }
}

-(IBAction)aiBuild:(id)sender {
    flatland->agent->buildAI(flatland->board, _dynamic);
}

- (void) move:(int) action {
    flatland->agent->agentDirection = flatland->board->updateDirection(action, flatland->agent->agentDirection);
    int boardResponse = flatland->board->performAction(flatland->agent->agentDirection, flatland->agent->agentPosition);
    flatland->agent->currentScore += boardResponse;
    flatland->agent->agentPosition = flatland->board->agentPosition;
    [_fview drawBoard:flatland];
    [_scoreText setStringValue:[NSString stringWithFormat:@"%d",flatland->agent->currentScore]];
    
    if (boardResponse == flatland->board->poisonEffect) {
        poisonEaten+=1;
        cout << "Poison eaten = " << poisonEaten << ", food eaten = " << foodEaten << "\n";
    }
    else if (boardResponse == flatland->board->foodEffect){
        foodEaten+=1;
        cout << "Poison eaten = " << poisonEaten << ", food eaten = " << foodEaten << "\n";
    }
}

-(IBAction)dynamicCheckButton:(id)sender {
    if (_dynamic) {
        _dynamic = false;
    }
    else {
        _dynamic = true;
    }
}

@end
    

    
    
    
    
