//
//  BoidView.m
//
//
//  Copyright (c) 2015 Anders Fuglseth. All rights reserved.
//

#import "FlatView.h"

@implementation FlatView

int dimension = 10;
const float edgeSize = 0.009;
const float startPosition = -1.f+edgeSize;


- (void)initWithDimension: (int)dim {
    
    dimension = dim;
    
}

- (void)drawBoard:(Flatland*) f
{
    
   
    glClearColor(0.3, 0.3, 0.3, 0);
    glClear(GL_COLOR_BUFFER_BIT);

    
    
    for (int j=0; j<dimension; j++) {
        for (int i=0; i<dimension; i++) {
            
            [self setColor:f->board->getPositionValue(i, j)];
            
            [self drawSquare_withPositionX: i andPositionY: j];
            //[self drawNumber: b->getPositionValue(i, j) PositionX: i andPositionY: j];
            
        }
    }
    [self drawArrow_withPositionX:f->agent->agentPosition.first positionY:f->agent->agentPosition.second andDirection:f->agent->agentDirection];
    
    glFlush();
}

- (void)drawSquare_withPositionX:(int) X andPositionY:(int) Y
{
    float size = (2.f-edgeSize)/dimension;
    
    float positionX = startPosition+size*X;
    float positionY =startPosition+size*Y;
    
    
    glBegin(GL_QUADS);
    {
        glVertex2f (positionX + size - edgeSize, positionY + size - edgeSize);
        glVertex2f (positionX,                   positionY + size - edgeSize);
        glVertex2f (positionX,                   positionY);
        glVertex2f (positionX + size - edgeSize, positionY);
    }
    glEnd();
   
}

- (void)drawArrow_withPositionX:(int) X positionY:(int)Y andDirection:(int)dir
{
    
    glColor3f(1.f, 1.f, 1.f);
    
    float xBodyAdjust = 0;
    float yBodyAdjust = 0;
    float xNormalAdjust1 = 1.0;
    float xNormalAdjust2 = 0.0;
    float yNormalAdjust1 = 0.0;
    float yNormalAdjust2 = 1.0;
    
    if (dir == 0) {
        xBodyAdjust = 0.40;
        yBodyAdjust = 0;
        xNormalAdjust1 = 1.0;
        xNormalAdjust2 = 0.0;
        yNormalAdjust1 = 0.0;
        yNormalAdjust2 = 0.2;
    }
    if (dir == 1) {
        xBodyAdjust = 0;
        yBodyAdjust = 0.40;
        xNormalAdjust1 = 0.2;
        xNormalAdjust2 = 0.0;
        yNormalAdjust1 = 0.0;
        yNormalAdjust2 = 1.0;
    }
    if (dir == 2) {
        xBodyAdjust = 0.40;
        yBodyAdjust = 0;
        xNormalAdjust1 = 1.0;
        xNormalAdjust2 = 0.0;
        yNormalAdjust1 = 0.8;
        yNormalAdjust2 = 1.0;
    }
    if (dir == 3) {
        xBodyAdjust = 0;
        yBodyAdjust = 0.40;
        xNormalAdjust1 = 1.0;
        xNormalAdjust2 = 0.8;
        yNormalAdjust1 = 0.0;
        yNormalAdjust2 = 1.0;
    }
    
    float arrowBodyX = (2.f-edgeSize)/dimension * xBodyAdjust;
    float arrowBodyY = (2.f-edgeSize)/dimension * yBodyAdjust;
    
    float xArrowNormal1 = (2.f-edgeSize)/dimension * xNormalAdjust1;
    float xArrowNormal2 = (2.f-edgeSize)/dimension * xNormalAdjust2;
    float yArrowNormal1 = (2.f-edgeSize)/dimension * yNormalAdjust1;
    float yArrowNormal2 = (2.f-edgeSize)/dimension * yNormalAdjust2;
    
    float size = (2.f-edgeSize)/dimension;
    
    
    float positionX = startPosition+size*X;
    float positionY =startPosition+size*Y;
    
    
    
    glBegin(GL_QUADS);
    {
        glVertex2f (positionX + size - edgeSize - arrowBodyX, positionY + size - edgeSize - arrowBodyY);
        glVertex2f (positionX                   + arrowBodyX, positionY + size - edgeSize - arrowBodyY);
        glVertex2f (positionX                   + arrowBodyX, positionY +                   arrowBodyY);
        glVertex2f (positionX + size - edgeSize - arrowBodyX, positionY +                   arrowBodyY);
    }
    glEnd();
    
    glBegin(GL_QUADS);
    {
        glVertex2f (positionX + xArrowNormal1 - edgeSize,  positionY + yArrowNormal2 - edgeSize);
        glVertex2f (positionX + xArrowNormal2,             positionY + yArrowNormal2 - edgeSize);
        glVertex2f (positionX + xArrowNormal2,             positionY + yArrowNormal1);
        glVertex2f (positionX + xArrowNormal1 - edgeSize , positionY + yArrowNormal1);
    }
    glEnd();
    
    
}


-(void)setColor:(int) c {
    if (c==0) {
        glColor3f(0.8f, 0.8f, 0.8f);
    }
    else if (c==1) {
        glColor3f(108.0/255, 213.0/255, 255.0/255); //ice blue
    }
    else if (c==2) {
        //glColor3f(0.4f, 0.8f, 0.0f); //light green
        glColor3f(76.0/255,  187.0/255, 120.0/255); //green
    }
    else if (c==3) {
       //glColor3f(0.8f, 0.1f, 0.0f); //red
        glColor3f(237.0/255, 64.0/255.0, 64.0/255.0); //red
        
    }
    
}


- (void)drawRect:(NSRect)dirtyRect
{
    [super drawRect:dirtyRect];
//    glClearColor(0.7, 0.7, 0.7, 0);
//    glClear(GL_COLOR_BUFFER_BIT);
//    glColor3f(0.8f, 0.0f, 0.0f);
//    glFlush();
}



@end

