//
//  GameBoard.h
//  Solver2048
//
//  Created by Anders Fuglseth on 30.10.14.
//  Copyright (c) 2014 Anders Fuglseth. All rights reserved.
//

#ifndef __Solver2048__GameBoard__
#define __Solver2048__GameBoard__

#include <stdio.h>
#include <string>

#include <iostream>

#include <vector>

class GameBoard {
public:
    
    GameBoard();
    
    ~GameBoard();
    
    GameBoard (int dimensions, double foodDist, double poisonDist, int poisonEffect, int foodEffect);
    
    GameBoard (const GameBoard &b);
    
    int getPositionValue(int positionX, int positionY);
    
    void setPositionValue(int positionX, int positionY, int value);
    
    void setFoodAndPoisonDist(double foodDist, double poisonDist);
    
    void nullify ();
    
    void fillRandom ();
    
    bool fill (double chance);
    
    int updateDirection (int action, int direction);
    int performAction (int direction, std::pair<int, int> position);
    
    std::pair<int, int> agentPosition;
    
    std::vector<bool>* getAgentInput(int direction);
    
    std::string toString();
    
    int dimensions;
    
    int* board;
    
    int poisonEffect = 2;
    
    int foodEffect = 2;
    
    
    void setStaticScenario (int scenario);
    
private:
    
    double foodDist;
    double poisonDist;
    
};

#endif /* defined(__Solver2048__GameBoard__) */
