//
//  EMTI_PopulationES.hpp //ES = Early stopping
//  EMTI_0.2_swift
//
//  Created by 2016 Anders Nikolai Fuglseth on 07.04.2016.
//

#ifndef EMTI_PopulationES_hpp
#define EMTI_PopulationES_hpp

#include <stdio.h>

#include "EMTI_Population.hpp"

class EMTI_PopulationES : public EMTI_Population {
public:
    
    
    EMTI_PopulationES (vector<int>* fullAttributeScope, vector<vector<unsigned>>* trainingSet, int maxTreeSize, int populationSize, int treeSize_fitnessWeight, float mutationRate, float crossOverRateParameter, bool exerciseTree, int parentSelectionType, int adultSelectionType, bool verbose = false, bool verboseplus = false, bool writePlotData = false, std::string plotOutputLocation = "", int tournamentSizeParameter = 1, float epsilonParameter = 1, float spiceRatio = 0.1);
    
    ~EMTI_PopulationES ();
    
    void do_evolution_cycle ();
    
    bool doPostCycle_rollBackCheck();
    
    double previousValidationSetAccuracy = 0;
    double currentValidationSetAccuracy = 0;
    double statisticsValidationSetAccuracy = 0;
    
    vector<EMTI_TreeCreature*>* previousAdults;
    EMTI_TreeCreature* previousAdultBestIndividual;
    
    int rollBackCount = 0;
    
    vector<vector<unsigned>>* validationSet;
    
private:
    
    bool rollBackCounter = false;
    
    vector<vector<unsigned>>* getNewDataSubset(vector<vector<unsigned>>* dataSet, double start, double end);
    
    double calculateValidationSetAccuracy();
    
    vector<EMTI_TreeCreature*>* make_copy(vector<EMTI_TreeCreature*>* original);
    
    
    
};

#endif /* EMTI_PopulationES_hpp */
