//
//  EMTI_PopulationES3.hpp
//  EMTI_0.2_swift
//
//  Created by 2016 Anders Nikolai Fuglseth on 07.04.2016.
//
// size control

#ifndef EMTI_PopulationES3_hpp
#define EMTI_PopulationES3_hpp

#include <stdio.h>

#include "EMTI_Population.hpp"

class EMTI_PopulationES3 : public EMTI_Population {
public:
    
    
    EMTI_PopulationES3 (vector<int>* fullAttributeScope, vector<vector<unsigned>>* trainingSet, int maxTreeSize, int populationSize, int treeSize_fitnessWeight, float mutationRate, float crossOverRateParameter, bool exerciseTree, int parentSelectionType, int adultSelectionType, bool verbose = false, bool verboseplus = false, bool writePlotData = false, std::string plotOutputLocation = "", int tournamentSizeParameter = 1, float epsilonParameter = 1, float spiceRatio = 0.1);
    
    ~EMTI_PopulationES3 ();
    
    void do_evolution_cycle ();
    
    bool doPostCycle_rollBackCheck();
    
    double previousValidationSetAccuracy = 0;
    double currentValidationSetAccuracy = 0;
    double statisticsValidationSetAccuracy = 0;
    
    vector<EMTI_TreeCreature*>* previousAdults;
    EMTI_TreeCreature* previousAdultBestIndividual;
    
    int rollBackCount = 0;
    
private:
    
    vector<vector<unsigned>>* validationSet;
    
    vector<vector<unsigned>>* getNewDataSubset(vector<vector<unsigned>>* dataSet, double start, double end);
    
    double calculateValidationSetAccuracy();
    
    int rollBackCounter = 0;
    
    bool postCycle_rollBackCounter = false;
    
    const int rollBackThreshold = 30;
    
    
};

#endif /* EMTI_PopulationES3_hpp */
