//
//  GraphView.swift
//  EMTI_0.2_swift
//
//  Created by 2016 Anders Nikolai Fuglseth on 09.02.2016.
//

import Cocoa

@IBDesignable

class GraphView: NSView {
    
    var graphPoints1:[Float] = []
    var graphPoints2:[Float] = []
    var graphPoints3:[Float] = []
    
    //NSColor(red: CGFloat(0xd4)/0xff, green: CGFloat(0x12)/0xff, blue: CGFloat(0x12)/0xff, alpha: 1.0); //dark red
    //NSColor(red: CGFloat(0xcc)/0xff, green: CGFloat(0x70)/0xff, blue: CGFloat(0x23)/0xff, alpha: 1.0); //orange
    //NSColor(red: CGFloat(0x4e)/0xff, green: CGFloat(0x34)/0xff, blue: CGFloat(0xab)/0xff, alpha: 1.0); //purple
    //NSColor(red: CGFloat(0x00)/0xff, green: CGFloat(0x80)/0xff, blue: CGFloat(0x00)/0xff, alpha: 1.0); //green
    
    var color1:NSColor = NSColor(red: CGFloat(0x00)/0xff, green: CGFloat(0x80)/0xff, blue: CGFloat(0x00)/0xff, alpha: 1.0); //green
    var color2:NSColor = NSColor(red: CGFloat(0xcc)/0xff, green: CGFloat(0x70)/0xff, blue: CGFloat(0x23)/0xff, alpha: 1.0); //orange
    var color3:NSColor = NSColor(red: CGFloat(0x4e)/0xff, green: CGFloat(0x34)/0xff, blue: CGFloat(0xab)/0xff, alpha: 1.0); //purple
    
    
    
    
    
    override func drawRect(dirtyRect: NSRect) {
        super.drawRect(dirtyRect)
        
        // Drawing code here.
        
        let path = NSBezierPath(rect: dirtyRect);
        NSColor.whiteColor().setFill()
        path.fill()
        
        self.wantsLayer = true;
        self.layer!.borderWidth = 2.0;
        self.layer!.borderColor = NSColor.blackColor().CGColor;
        
        
        drawGraph();
        
    }
    
    func drawGraph () {
        
        
        if (graphPoints1.count >= 2 && graphPoints2.count >= 2 && graphPoints3.count >= 3) {
            
            let margin:CGFloat = 10.0
            let columnXPoint = { (column:Int) -> CGFloat in
                //Calculate gap between points
                let spacer = (self.bounds.width - margin*2 - 4) /
                    CGFloat((self.graphPoints1.count - 1))
                var x:CGFloat = CGFloat(column) * spacer
                x += margin + 2
                return x
            }
            
            let topBorder:CGFloat = -30
            let bottomBorder:CGFloat = 50
            let graphHeight = self.bounds.height - topBorder - bottomBorder
            
            let maxes:[Float] = [graphPoints1.maxElement()!, graphPoints2.maxElement()!, graphPoints3.maxElement()!];
            
            
            let maxValue = maxes.maxElement();
            let columnYPoint = { (graphPoint:Float) -> CGFloat in
                let y:CGFloat = CGFloat(graphPoint) /
                    CGFloat(maxValue!) * graphHeight
                //y = graphHeight + topBorder - y // Flip the graph
                return y
            }
            
            //set up the points line
            let graphPath1 = NSBezierPath()
            //go to start of line
            graphPath1.moveToPoint(CGPoint(x:columnXPoint(0),
                y:columnYPoint(graphPoints2[0])))
            
            //add points for each item in the graphPoints array
            //at the correct (x, y) for the point
            for i in 1..<graphPoints1.count-1 {
                let nextPoint = CGPoint(x:columnXPoint(i),
                    y:columnYPoint(graphPoints1[i]))
                graphPath1.lineToPoint(nextPoint)
            }
            graphPath1.lineWidth = 3.0
            color1.setFill()
            color1.setStroke()
            graphPath1.stroke();
            
            //set up the points line
            let graphPath2 = NSBezierPath()
            //go to start of line
            graphPath2.moveToPoint(CGPoint(x:columnXPoint(0),
                y:columnYPoint(graphPoints1[0])))
            
            //add points for each item in the graphPoints array
            //at the correct (x, y) for the point
            for j in 1..<graphPoints2.count-1 {
                let nextPoint = CGPoint(x:columnXPoint(j),
                    y:columnYPoint(graphPoints2[j]))
                graphPath2.lineToPoint(nextPoint)
            }
            graphPath2.lineWidth = 3.0
            color2.setFill()
            color2.setStroke()
            graphPath2.stroke();
            
            //set up the points line
            let graphPath3 = NSBezierPath()
            //go to start of line
            graphPath3.moveToPoint(CGPoint(x:columnXPoint(0),
                y:columnYPoint(graphPoints3[0])))
            
            //add points for each item in the graphPoints array
            //at the correct (x, y) for the point
            for j in 1..<graphPoints3.count-1 {
                let nextPoint = CGPoint(x:columnXPoint(j),
                    y:columnYPoint(graphPoints3[j]))
                graphPath3.lineToPoint(nextPoint)
            }
            graphPath3.lineWidth = 3.0
            color3.setFill()
            color3.setStroke()
            graphPath3.stroke();
            
        }
        
    }
    
}
