//
//  EMTI_Population_Wrapper.h
//  EMTI_0.2_swift
//
//  Created by 2016 Anders Nikolai Fuglseth on 09.02.2016.
//

#import <Foundation/Foundation.h>

@interface EMTI_Swift_Wrapper : NSObject


- (void)data_init:(const char*) filePath;

- (bool)populationInit_populationSize:(int)psize sizeWeight:(int)sW mutationRate:(float)mR crossoverRate: (float)cR adultSelectionType: (int)aT parentSelectionType: (int)pT rejectWorseGeneration: (int)rwg spiceRation: (float)sR tournamentSize: (int)tsize epsilonParameter: (float)eP trainingSetSize: (float) trainingSetSize;

- (void)performanceFeedbackOutput;

- (void)reset_cycleCount;

- (void)population_delete;

- (void)doEvolutionCycle;

- (void)conductExperiment;

- (void)exportTreeToDot;

@property NSString* dataAttributesCountText;
@property NSString* dataInstancesCountText;
@property NSString* dataAttributeValuesText;

@property NSString* currentGenerationInfoText;
@property NSString* resultsInfoText;

@property int cyclecount;

@property double fitnessBest;
@property double fitnessAverage;
@property double treeSizeBest;
@property double treeSizeAverage;

@property double TESTvalidationAccuracy;
@property double TESTinternalValidationAccuracy;
@property double TESTmaxTreeSize;

@end
