/*
 By Anders N. Fuglseth, 2016
 
 usage:
 argument 1: amount of data instances to be generated
 argument 2: (optional) attribute noice percentage (also adds one irrelevant and one correlated attribute)
 
 */

#include <stdio.h>
#include <time.h>
#include <stdlib.h>

int main(int argc, const char* argv[])
{
    int instances, i;
    int noise, entryNoiseChance;
    int noiseaddedCount;
    
    entryNoiseChance = 0;
    
    instances = 100;
    noiseaddedCount = 0;
    
    if (argc == 1) {
        printf("Number of instances set to %d\n\n", instances);
    }
    else if (argc == 2) {
        instances = atoi(argv[1]);
        printf("Number of instances set to %d\n\n", instances);
    }
    else if (argc == 3) {
        instances = atoi(argv[1]);
        printf("Number of instances set to %d\n", instances);
        if (atoi(argv[2]) == 0) {
            noise = 1;
            printf("Added two redundant attributes!\n\n");
        }
        if (atoi(argv[2]) > 0) {
            
            entryNoiseChance = atoi(argv[2]);
            noise = 1;
            printf("%d%% noise added and two redundant attributes!\n\n", entryNoiseChance);
        }
    }
    else {
        printf("Error: Wrong input parameters!\n");
        exit(0);
    }
    
    srand(time(NULL));
    
    for (i = 0; i < instances; i++) {
        
        int attr[6], category, r;
        
        int j;
        for (j = 0; j < 4; j++) {
            
            int r = rand() % 3;
            
            attr[j] = r;
            
            if (r == 0) {
                printf("red,");
            }
            else if (r == 1) {
                printf("green,");
            }
            else if (r == 2) {
                printf("blue,");
            }
        }
        
        
        if (noise) {
            
            r = rand() % 3;
            attr[4] = r;
            if (r == 0) {
                printf("sunny,");
            }
            else if (r == 1) {
                printf("overcast,");
            }
            else if (r == 2) {
                printf("raining,");
            }
            
            if (attr[0] == 0) {
                attr[5] = 0;
                printf("a is blue,");
            }
            else {
                printf("a is not blue,");
            }
            
        }
        
        category = 0;
        
        r = rand() % 100;
        
        if (entryNoiseChance && r <= entryNoiseChance) {
            category = rand() % 2;
            noiseaddedCount++;
        }
        else {
            
            if (attr[0] == attr[3]) {
                category++;
            }
            if (attr[1] == attr[2]) {
                category++;
            }
            
            if ((attr[0] == attr[1] && attr[0] == attr[2]) ||
                (attr[0] == attr[1] && attr[0] == attr[3]) ||
                (attr[0] == attr[2] && attr[0] == attr[3]) ||
                (attr[3] == attr[1] && attr[3] == attr[2]) ){
                category = 0;
            }
        }
        
        printf("%d\n", category);
    }
    
    if (entryNoiseChance) {
        printf("\n\n");
        printf("%d noise instances added.\n", noiseaddedCount);
    }
}
